// SliderButton.cpp : implementation file
//

#include "stdafx.h"
#include "Slider.h"
#include "SliderButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSliderButton

IMPLEMENT_DYNCREATE(CSliderButton, CCmdTarget)

CSliderButton::CSliderButton()
{
	m_LinkFile		= _T("");
	m_DisplayName	= _T("");
	m_cFontText		= _T("Lucida Console");

	m_nFontHeight = 10;
	m_TextPos.x = 0;
	m_TextPos.y = 0;

	m_IconPos.x = 0;
	m_IconPos.y = 0;

	m_IconSize = 16;
	m_hIcon = NULL;

	m_Rect.SetRectEmpty();

	m_clrFontColor = RGB(0,0,0);
	m_clrFontHighliteColor = RGB(255,255,255);

	m_bCurrentlyHighlighted = FALSE;
}

CSliderButton::~CSliderButton()
{
	DestroyIcon(m_hIcon);
}


BEGIN_MESSAGE_MAP(CSliderButton, CCmdTarget)
	//{{AFX_MSG_MAP(CSliderButton)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSliderButton message handlers

BOOL CSliderButton::HitTest(CPoint point)
{
	return m_Rect.PtInRect(point);
}

void CSliderButton::Draw(CDC *pDC, BOOL bDrawFocus)
{
	if(NULL == pDC)
		return;

	if(!m_DisplayName.GetLength())
		return;

	if(bDrawFocus)
		m_bCurrentlyHighlighted = TRUE;
	else
		m_bCurrentlyHighlighted = FALSE;

	int OldBackMode = pDC->SetBkMode(TRANSPARENT);
	COLORREF OldTextColor = pDC->SetTextColor(bDrawFocus ? m_clrFontHighliteColor : m_clrFontColor);

	CFont Font;
	Font.CreatePointFont(10 * m_nFontHeight, m_cFontText, pDC);

	CFont* pOldFont = (CFont*)pDC->SelectObject(&Font);

	
	
	pDC->ExtTextOut(m_TextPos.x, m_TextPos.y, ETO_CLIPPED, m_Rect, m_DisplayName, NULL);


	pDC->SetBkMode(OldBackMode);
	pDC->SetTextColor(OldTextColor);

	if(pOldFont)
		pDC->SelectObject(pOldFont);
}

void CSliderButton::Execute()
{
	// Called to execute our lnk file
	SHELLEXECUTEINFO si;
	memset(&si, 0, sizeof(si));
	si.cbSize = sizeof(SHELLEXECUTEINFO);

	si.lpVerb = NULL;
	si.nShow = 1;
	si.fMask = SEE_MASK_DOENVSUBST;
	si.lpFile = m_LinkFile;
	ShellExecuteEx(&si);	
}

BOOL CSliderButton::IsCurrentTracking()
{
	// Return if we are highlighted
	return m_bCurrentlyHighlighted;
}
