// TasksChild.cpp: implementation of the CTasksChild class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "slider.h"
#include "TasksChild.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTasksChild::CTasksChild()
{

}

CTasksChild::~CTasksChild()
{

}

BOOL CTasksChild::AssembleVerticalBitmap()
{
	// Function will assemble the Child bitmap for verticle menu's
	CWindowDC dc(NULL);
	
	CRect		rect;
	CDC			memDC;
	CDC			workDC;

	CBitmap 	bitmap;
	CBitmap		bitmapTop;
	CBitmap		bitmapBottom;
	CBitmap		bitmapMiddle;

	DWORD		dwBitmapLength  = 0;
	DWORD		dwCurPos		= 0;

	int			nNumberOfTasks	= 0;
	int			nIconIndex		= 0;
	int			i				= 0;

	CString		cIconPath	= _T("");
	CString		cDisplay	= _T("");
	CString		cErrorText  = _T("");

	HICON		hIcon		= NULL;

	BITMAP		bm;

	// Get the Top
	if(LoadBitmap(bitmapTop, m_cTopBitmapPath))
	{
		bitmapTop.GetBitmap(&bm);
		dwBitmapLength += bm.bmHeight;
	}

	// Do the Bottom
	if(LoadBitmap(bitmapBottom, m_cBottomBitmapPath))
	{
		bitmapBottom.GetBitmap(&bm);

		dwBitmapLength += bm.bmHeight;
	}

	// OK - now get a snapshot of the processlist
	CProcessList * pProcessList = CProcessList::Create();

	ASSERT(pProcessList != 0);

	pProcessList->SnapShot();
	CProcess * pProcess = 0;

	// Walk the list to get a count
	while((pProcess = pProcessList->GetNextProcess()) != 0) 
	{
		nNumberOfTasks++;
	}

	// Do the middle, this has to be here
	if(LoadBitmap(bitmapMiddle, m_cMiddleBitmapPath))
	{
		bitmapMiddle.GetBitmap(&bm);
		dwBitmapLength += (bm.bmHeight * nNumberOfTasks);
	}
	else
	{
		cErrorText.Format("Unable to load bitmap - %s", m_cMiddleBitmapPath);
		ErrorLog(cErrorText);

		return FALSE;
	}

	rect.left	= 0;
	rect.top	= 0;
	rect.right	= bm.bmWidth;
	rect.bottom	= dwBitmapLength;

	memDC.CreateCompatibleDC(&dc); 	
	workDC.CreateCompatibleDC(&dc); 	

	bitmap.CreateCompatibleBitmap(&dc, rect.Width(), rect.Height());	

	memDC.SelectObject(&bitmap);
	memDC.FillSolidRect(rect, RGB(255,0,255));

	// Assemble the Pieces

	// Top
	if(bitmapTop.m_hObject)
	{
		workDC.SelectObject(bitmapTop);

		bitmapTop.GetBitmap(&bm);
		memDC.BitBlt(0, dwCurPos, bm.bmWidth, bm.bmHeight, &workDC, 0, 0, SRCCOPY);

		dwCurPos += bm.bmHeight;
	}

	workDC.SelectObject(bitmapMiddle);

	bitmapMiddle.GetBitmap(&bm);

	if(m_bPrintText && m_Font.m_hObject)
	{
		memDC.SelectObject(m_Font);
		memDC.SetBkMode(TRANSPARENT);
		memDC.SetTextColor(m_clrFontColor);
	}

	// Got back to the begining
	pProcessList->SeekToBegin();

	while((pProcess = pProcessList->GetNextProcess()) != 0) 
	{
		memDC.BitBlt(0, dwCurPos, bm.bmWidth, bm.bmHeight, &workDC, 0, 0, SRCCOPY);

		// Create the Button class
		CSliderButton* pButton = new CSliderButton;

		if(NULL != pButton)
		{
			hIcon = NULL;

			// Set button rect
			pButton->m_Rect = CRect(0, dwCurPos, bm.bmWidth, dwCurPos + bm.bmHeight);

			if(m_bPrintIcon)
			{
				// Try to get the icon from Explorer
				SHFILEINFO shf;

				UINT nFlags = SHGFI_ICON;

				if(m_bUseSmallIcons)
					nFlags |= SHGFI_SMALLICON;
				else
					nFlags |= SHGFI_LARGEICON;

				SHGetFileInfo(pProcess->GetFilename(), NULL, &shf, sizeof(shf), nFlags);
				if (shf.hIcon != NULL)
					hIcon = shf.hIcon;

				if(NULL != hIcon)
				{
					DrawIconEx(memDC.m_hDC, 0 + m_nIconXAdj, dwCurPos + m_nIconYAdj, hIcon, 
						m_bUseSmallIcons ? 16 : 32, 
						m_bUseSmallIcons ? 16 : 32, 0, NULL, DI_NORMAL);

					// Store the Icon
					pButton->m_hIcon = hIcon;

					// Store the size
					pButton->m_IconSize = m_bUseSmallIcons ? 16 : 32;

					// Store the position
					pButton->m_IconPos = CPoint(dwCurPos + m_nIconXAdj, 0 + m_nIconYAdj);
				}
			}

			// Do the text
			cDisplay= _T("Cool");

			// Do the tooltip
			if(m_bUseToolTip)
				m_ToolTip.AddTool(this, cDisplay, pButton->m_Rect, i + 1);

			if(m_bPrintText)
			{
				memDC.TextOut(0 + m_nTextXAdj, dwCurPos + m_nTextYAdj, cDisplay);

				// Store the display
				pButton->m_DisplayName = cDisplay;

				// Store the text position
				pButton->m_TextPos = CPoint(0 + m_nTextXAdj, dwCurPos + m_nTextYAdj);

				// Store the Font info
				pButton->m_cFontText = m_cFontText;

				pButton->m_clrFontColor = m_clrFontColor;
				
				pButton->m_clrFontHighliteColor = m_clrFontHighliteColor;

				pButton->m_nFontHeight = m_nFontHeight;

			}

			// Add the button
			m_colSliderButtons.Add(pButton);
		}

		dwCurPos += bm.bmHeight;
		i++;
	}

	// Do the Bottom
	if(bitmapBottom.m_hObject)
	{
		workDC.SelectObject(bitmapBottom);

		bitmapBottom.GetBitmap(&bm);
		memDC.BitBlt(0, dwCurPos, bm.bmWidth, bm.bmHeight, &workDC, 0, 0, SRCCOPY);
	}

	m_Bitmap.Attach(bitmap.Detach());

	delete pProcessList;

	return TRUE;
}